Index: vm/vm_map.c
===================================================================
RCS file: /home/ncvs/src/sys/vm/vm_map.c,v
retrieving revision 1.204
diff -u -r1.204 vm_map.c
--- vm/vm_map.c	2001/06/22 06:35:22	1.204
+++ vm/vm_map.c	2001/07/04 02:54:17
@@ -173,7 +173,7 @@
 {
 	struct vmspace *vm;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
 	vm = zalloc(vmspace_zone);
 	CTR1(KTR_VM, "vmspace_alloc: %p", vm);
 	vm_map_init(&vm->vm_map, min, max);
@@ -201,8 +201,8 @@
 vmspace_free(vm)
 	struct vmspace *vm;
 {
+	GIANT_REQUIRED;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
 	if (vm->vm_refcnt == 0)
 		panic("vmspace_free: attempt to free already freed vmspace");
 
@@ -273,7 +273,8 @@
 {
 	vm_map_t result;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
+
 	result = zalloc(mapzone);
 	CTR1(KTR_VM, "vm_map_create: %p", result);
 	vm_map_init(result, min, max);
@@ -291,8 +292,8 @@
 	struct vm_map *map;
 	vm_offset_t min, max;
 {
+	GIANT_REQUIRED;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
 	map->header.next = map->header.prev = &map->header;
 	map->nentries = 0;
 	map->size = 0;
@@ -310,8 +311,7 @@
 vm_map_destroy(map)
 	struct vm_map *map;
 {
-
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
 	lockdestroy(&map->lock);
 }
 
@@ -400,8 +400,6 @@
  *	in the "entry" parameter.  The boolean
  *	result indicates whether the address is
  *	actually contained in the map.
- *
- *	Doesn't block.
  */
 boolean_t
 vm_map_lookup_entry(map, address, entry)
@@ -412,7 +410,7 @@
 	vm_map_entry_t cur;
 	vm_map_entry_t last;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
 	/*
 	 * Start looking either from the head of the list, or from the hint.
 	 */
@@ -491,8 +489,9 @@
 	vm_map_entry_t prev_entry;
 	vm_map_entry_t temp_entry;
 	vm_eflags_t protoeflags;
+
+	GIANT_REQUIRED;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
 	/*
 	 * Check that the start and end points are not bogus.
 	 */
@@ -654,7 +653,7 @@
 	vm_map_entry_t entry, next;
 	vm_offset_t end;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
 	if (start < map->min_offset)
 		start = map->min_offset;
 	if (start > map->max_offset)
@@ -723,7 +722,8 @@
 	vm_offset_t start;
 	int result, s = 0;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
+
 	start = *addr;
 
 	if (map == kmem_map)
@@ -768,8 +768,9 @@
 {
 	vm_map_entry_t next, prev;
 	vm_size_t prevsize, esize;
+
+	GIANT_REQUIRED;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
 	if (entry->eflags & MAP_ENTRY_IS_SUB_MAP)
 		return;
 
@@ -987,8 +988,9 @@
 {
 	vm_map_entry_t entry;
 	int result = KERN_INVALID_ARGUMENT;
+
+	GIANT_REQUIRED;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
 	vm_map_lock(map);
 
 	VM_MAP_RANGE_CHECK(map, start, end);
@@ -1027,7 +1029,7 @@
 	vm_map_entry_t current;
 	vm_map_entry_t entry;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
 	vm_map_lock(map);
 
 	VM_MAP_RANGE_CHECK(map, start, end);
@@ -1117,7 +1119,8 @@
 	vm_map_entry_t current, entry;
 	int modify_map = 0;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
+
 	/*
 	 * Some madvise calls directly modify the vm_map_entry, in which case
 	 * we need to use an exclusive lock on the map and we need to perform 
@@ -1270,8 +1273,9 @@
 {
 	vm_map_entry_t entry;
 	vm_map_entry_t temp_entry;
+
+	GIANT_REQUIRED;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
 	switch (new_inheritance) {
 	case VM_INHERIT_NONE:
 	case VM_INHERIT_COPY:
@@ -1457,8 +1461,9 @@
 	vm_map_entry_t start_entry;
 	vm_offset_t failed = 0;
 	int rv;
+
+	GIANT_REQUIRED;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
 	vm_map_lock(map);
 
 	VM_MAP_RANGE_CHECK(map, start, end);
@@ -1689,8 +1694,8 @@
 	vm_object_t object;
 	vm_ooffset_t offset;
 
-	mtx_assert(&Giant, MA_OWNED);
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
+
 	vm_map_lock_read(map);
 	VM_MAP_RANGE_CHECK(map, start, end);
 	if (!vm_map_lookup_entry(map, start, &entry)) {
@@ -1769,9 +1774,7 @@
 			int flags;
 
 			vm_object_reference(object);
-			mtx_unlock(&vm_mtx);
 			vn_lock(object->handle, LK_EXCLUSIVE | LK_RETRY, curproc);
-			mtx_lock(&vm_mtx);
 			flags = (syncio || invalidate) ? OBJPC_SYNC : 0;
 			flags |= invalidate ? OBJPC_INVAL : 0;
 			vm_object_page_clean(object,
@@ -1847,8 +1850,9 @@
 	vm_object_t object;
 	vm_map_entry_t entry;
 	vm_map_entry_t first_entry;
+
+	GIANT_REQUIRED;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
 	/*
 	 * Find the start of the region, and clip it
 	 */
@@ -1949,8 +1953,9 @@
 	vm_offset_t end;
 {
 	int result, s = 0;
+
+	GIANT_REQUIRED;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
 	if (map == kmem_map)
 		s = splvm();
 
@@ -1979,7 +1984,8 @@
 	vm_map_entry_t entry;
 	vm_map_entry_t tmp_entry;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
+
 	if (!vm_map_lookup_entry(map, start, &tmp_entry)) {
 		return (FALSE);
 	}
@@ -2026,8 +2032,9 @@
 	vm_pindex_t offidxstart, offidxend, idx;
 	vm_size_t size;
 	vm_ooffset_t offset;
+
+	GIANT_REQUIRED;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
 	orig_object = entry->object.vm_object;
 	if (orig_object->type != OBJT_DEFAULT && orig_object->type != OBJT_SWAP)
 		return;
@@ -2194,7 +2201,8 @@
 	vm_map_entry_t new_entry;
 	vm_object_t object;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
+
 	vm_map_lock(old_map);
 	old_map->infork = 1;
 
@@ -2303,8 +2311,9 @@
 	vm_map_entry_t new_stack_entry;
 	vm_size_t      init_ssize;
 	int            rv;
+
+	GIANT_REQUIRED;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
 	if (VM_MIN_ADDRESS > 0 && addrbos < VM_MIN_ADDRESS)
 		return (KERN_NO_SPACE);
 
@@ -2368,8 +2377,6 @@
  * the stack.  Also returns KERN_SUCCESS if addr is outside the
  * stack range (this is strange, but preserves compatibility with
  * the grow function in vm_machdep.c).
- *
- * Will grab vm_mtx if needed
  */
 int
 vm_map_growstack (struct proc *p, vm_offset_t addr)
@@ -2383,16 +2390,8 @@
 	int      grow_amount;
 	int      rv;
 	int      is_procstack;
-	int	hadvmlock;
 
-	hadvmlock = mtx_owned(&vm_mtx);
-	if (!hadvmlock)
-		mtx_lock(&vm_mtx);
-#define myreturn(rval)	do { \
-	if (!hadvmlock) \
-		mtx_unlock(&vm_mtx); \
-	return (rval); \
-} while (0)
+	GIANT_REQUIRED;
 	
 Retry:
 	vm_map_lock_read(map);
@@ -2400,12 +2399,12 @@
 	/* If addr is already in the entry range, no need to grow.*/
 	if (vm_map_lookup_entry(map, addr, &prev_entry)) {
 		vm_map_unlock_read(map);
-		myreturn (KERN_SUCCESS);
+		return (KERN_SUCCESS);
 	}
 
 	if ((stack_entry = prev_entry->next) == &map->header) {
 		vm_map_unlock_read(map);
-		myreturn (KERN_SUCCESS);
+		return (KERN_SUCCESS);
 	} 
 	if (prev_entry == &map->header) 
 		end = stack_entry->start - stack_entry->avail_ssize;
@@ -2423,14 +2422,14 @@
 	    addr >= stack_entry->start ||
 	    addr <  stack_entry->start - stack_entry->avail_ssize) {
 		vm_map_unlock_read(map);
-		myreturn (KERN_SUCCESS);
+		return (KERN_SUCCESS);
 	} 
 	
 	/* Find the minimum grow amount */
 	grow_amount = roundup (stack_entry->start - addr, PAGE_SIZE);
 	if (grow_amount > stack_entry->avail_ssize) {
 		vm_map_unlock_read(map);
-		myreturn (KERN_NO_SPACE);
+		return (KERN_NO_SPACE);
 	}
 
 	/* If there is no longer enough space between the entries
@@ -2449,7 +2448,7 @@
 		stack_entry->avail_ssize = stack_entry->start - end;
 
 		vm_map_unlock(map);
-		myreturn (KERN_NO_SPACE);
+		return (KERN_NO_SPACE);
 	}
 
 	is_procstack = addr >= (vm_offset_t)vm->vm_maxsaddr;
@@ -2460,7 +2459,7 @@
 	if (is_procstack && (ctob(vm->vm_ssize) + grow_amount >
 			     p->p_rlimit[RLIMIT_STACK].rlim_cur)) {
 		vm_map_unlock_read(map);
-		myreturn (KERN_NO_SPACE);
+		return (KERN_NO_SPACE);
 	}
 
 	/* Round up the grow amount modulo SGROWSIZ */
@@ -2512,8 +2511,7 @@
 	}
 
 	vm_map_unlock(map);
-	myreturn (rv);
-#undef myreturn
+	return (rv);
 }
 
 /*
@@ -2527,7 +2525,7 @@
 	struct vmspace *newvmspace;
 	vm_map_t map = &p->p_vmspace->vm_map;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
 	newvmspace = vmspace_alloc(map->min_offset, map->max_offset);
 	bcopy(&oldvmspace->vm_startcopy, &newvmspace->vm_startcopy,
 	    (caddr_t) (newvmspace + 1) - (caddr_t) &newvmspace->vm_startcopy);
@@ -2555,7 +2553,7 @@
 	struct vmspace *oldvmspace = p->p_vmspace;
 	struct vmspace *newvmspace;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
 	if (oldvmspace->vm_refcnt == 1)
 		return;
 	newvmspace = vmspace_fork(oldvmspace);
@@ -2588,9 +2586,6 @@
  *	specified, the map may be changed to perform virtual
  *	copying operations, although the data referenced will
  *	remain the same.
- *
- *	Can block locking maps and while calling vm_object_shadow().
- *	Will drop/reaquire the vm_mtx.
  */
 int
 vm_map_lookup(vm_map_t *var_map,		/* IN/OUT */
@@ -2607,7 +2602,7 @@
 	vm_prot_t prot;
 	vm_prot_t fault_type = fault_typea;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
 RetryLookup:;
 
 	/*
@@ -2779,8 +2774,7 @@
 	/*
 	 * Unlock the main-level map
 	 */
-
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
 	vm_map_unlock_read(map);
 }
 
@@ -2808,8 +2802,9 @@
 	vm_pindex_t first_pindex, osize, oindex;
 	off_t ooffset;
 	int cnt;
+
+	GIANT_REQUIRED;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
 	if (npages)
 		*npages = 0;
 
@@ -3021,8 +3016,6 @@
  * Performs the copy_on_write operations necessary to allow the virtual copies
  * into user space to work.  This has to be called for write(2) system calls
  * from other processes, file unlinking, and file size shrinkage.
- *
- * Requires that the vm_mtx is held
  */
 void
 vm_freeze_copyopts(object, froma, toa)
@@ -3033,7 +3026,7 @@
 	vm_object_t robject;
 	vm_pindex_t idx;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
 	if ((object == NULL) ||
 		((object->flags & OBJ_OPT) == 0))
 		return;
Index: vm/vm_map.h
===================================================================
RCS file: /home/ncvs/src/sys/vm/vm_map.h,v
retrieving revision 1.64
diff -u -r1.64 vm_map.h
--- vm/vm_map.h	2001/06/09 18:06:57	1.64
+++ vm/vm_map.h	2001/07/04 03:12:33
@@ -212,7 +212,6 @@
 	do { \
 		lockmgr(&(map)->lock, LK_DRAIN|LK_INTERLOCK, \
 			&(map)->ref_lock, curproc); \
-		mtx_lock(&vm_mtx); \
 		(map)->timestamp++; \
 	} while(0)
 
@@ -227,11 +226,9 @@
 #define	vm_map_lock(map) \
 	do { \
 		vm_map_printf("locking map LK_EXCLUSIVE: %p\n", map); \
-		mtx_assert(&vm_mtx, MA_OWNED); \
-		if (lockmgr(&(map)->lock, LK_EXCLUSIVE | LK_INTERLOCK, \
-		   	&vm_mtx, curproc) != 0) \
+		if (lockmgr(&(map)->lock, LK_EXCLUSIVE, \
+		   	NULL, curproc) != 0) \
 			panic("vm_map_lock: failed to get lock"); \
-		mtx_lock(&vm_mtx); \
 		(map)->timestamp++; \
 	} while(0)
 
@@ -244,10 +241,8 @@
 #define	vm_map_lock_read(map) \
 	do { \
 		vm_map_printf("locking map LK_SHARED: %p\n", map); \
-		mtx_assert(&vm_mtx, MA_OWNED); \
-		lockmgr(&(map)->lock, LK_SHARED | LK_INTERLOCK, \
-		    &vm_mtx, curproc); \
-		mtx_lock(&vm_mtx); \
+		lockmgr(&(map)->lock, LK_SHARED, \
+		    NULL, curproc); \
 	} while (0)
 
 #define	vm_map_unlock_read(map) \
@@ -261,8 +256,7 @@
 	int error;
 
 	vm_map_printf("locking map LK_EXCLUPGRADE: %p\n", map); 
-	error = lockmgr(&map->lock, LK_EXCLUPGRADE | LK_INTERLOCK, &vm_mtx, p);
-	mtx_lock(&vm_mtx);
+	error = lockmgr(&map->lock, LK_EXCLUPGRADE, NULL, p);
 	if (error == 0)
 		map->timestamp++;
 	return error;
Index: vm/vm_meter.c
===================================================================
RCS file: /home/ncvs/src/sys/vm/vm_meter.c,v
retrieving revision 1.55
diff -u -r1.55 vm_meter.c
--- vm/vm_meter.c	2001/06/01 13:23:28	1.55
+++ vm/vm_meter.c	2001/07/04 02:54:17
@@ -145,10 +145,9 @@
 	/*
 	 * Mark all objects as inactive.
 	 */
-	mtx_lock(&vm_mtx);
+	GIANT_REQUIRED;
 	TAILQ_FOREACH(object, &vm_object_list, object_list)
 		vm_object_clear_flag(object, OBJ_ACTIVE);
-	mtx_unlock(&vm_mtx);
 	/*
 	 * Calculate process statistics.
 	 */
@@ -199,7 +198,6 @@
 		 * Note active objects.
 		 */
 		paging = 0;
-		mtx_lock(&vm_mtx);
 		for (map = &p->p_vmspace->vm_map, entry = map->header.next;
 		    entry != &map->header; entry = entry->next) {
 			if ((entry->eflags & MAP_ENTRY_IS_SUB_MAP) ||
@@ -208,7 +206,6 @@
 			vm_object_set_flag(entry->object.vm_object, OBJ_ACTIVE);
 			paging |= entry->object.vm_object->paging_in_progress;
 		}
-		mtx_unlock(&vm_mtx);
 		if (paging)
 			totalp->t_pw++;
 	}
@@ -216,7 +213,6 @@
 	/*
 	 * Calculate object memory usage statistics.
 	 */
-	mtx_lock(&vm_mtx);
 	TAILQ_FOREACH(object, &vm_object_list, object_list) {
 		/*
 		 * devices, like /dev/mem, will badly skew our totals
@@ -240,7 +236,6 @@
 		}
 	}
 	totalp->t_free = cnt.v_free_count + cnt.v_cache_count;
-	mtx_unlock(&vm_mtx);
 	return (sysctl_handle_opaque(oidp, totalp, sizeof total, req));
 }
 
Index: vm/vm_mmap.c
===================================================================
RCS file: /home/ncvs/src/sys/vm/vm_mmap.c,v
retrieving revision 1.122
diff -u -r1.122 vm_mmap.c
--- vm/vm_mmap.c	2001/05/24 18:04:29	1.122
+++ vm/vm_mmap.c	2001/07/04 02:54:17
@@ -113,8 +113,9 @@
 	struct proc *p;
 	struct sbrk_args *uap;
 {
-
 	/* Not yet implemented */
+	/* mtx_lock(&Giant); */
+	/* mtx_unlock(&Giant); */
 	return (EOPNOTSUPP);
 }
 
@@ -130,8 +131,9 @@
 	struct proc *p;
 	struct sstk_args *uap;
 {
-
 	/* Not yet implemented */
+	/* mtx_lock(&Giant); */
+	/* mtx_unlock(&Giant); */
 	return (EOPNOTSUPP);
 }
 
@@ -148,7 +150,7 @@
 	struct proc *p;
 	struct getpagesize_args *uap;
 {
-
+	/* MP SAFE */
 	p->p_retval[0] = PAGE_SIZE;
 	return (0);
 }
@@ -268,7 +270,7 @@
 	     addr < round_page((vm_offset_t)vms->vm_daddr + MAXDSIZ)))
 		addr = round_page((vm_offset_t)vms->vm_daddr + MAXDSIZ);
 
-	mtx_lock(&Giant);
+	mtx_lock(&Giant);	/* syscall marked mp-safe but isn't */
 	if (flags & MAP_ANON) {
 		/*
 		 * Mapping blank space is trivial.
@@ -315,8 +317,10 @@
 			/*
 			 * Get the proper underlying object
 			 */
-			if (VOP_GETVOBJECT(vp, &obj) != 0)
-				return (EINVAL);
+			if (VOP_GETVOBJECT(vp, &obj) != 0) {
+				error = EINVAL;
+				goto done;
+			}
 			vp = (struct vnode*)obj->handle;
 		}
 		/*
@@ -518,6 +522,8 @@
 	if ((flags & (MS_ASYNC|MS_INVALIDATE)) == (MS_ASYNC|MS_INVALIDATE))
 		return (EINVAL);
 
+	mtx_lock(&Giant);
+
 	map = &p->p_vmspace->vm_map;
 
 	/*
@@ -527,10 +533,6 @@
 	 * the range of the map entry containing addr. This can be incorrect
 	 * if the region splits or is coalesced with a neighbor.
 	 */
-#ifndef BLEED
-	mtx_lock(&Giant);
-#endif
-	mtx_lock(&vm_mtx);
 	if (size == 0) {
 		vm_map_entry_t entry;
 
@@ -538,10 +540,7 @@
 		rv = vm_map_lookup_entry(map, addr, &entry);
 		vm_map_unlock_read(map);
 		if (rv == FALSE) {
-			mtx_unlock(&vm_mtx);
-#ifndef BLEED
 			mtx_unlock(&Giant);
-#endif
 			return (EINVAL);
 		}
 		addr = entry->start;
@@ -554,10 +553,8 @@
 	rv = vm_map_clean(map, addr, addr + size, (flags & MS_ASYNC) == 0,
 	    (flags & MS_INVALIDATE) != 0);
 
-	mtx_unlock(&vm_mtx);
-#ifndef BLEED
 	mtx_unlock(&Giant);
-#endif
+
 	switch (rv) {
 	case KERN_SUCCESS:
 		break;
@@ -610,20 +607,17 @@
 	if (VM_MIN_ADDRESS > 0 && addr < VM_MIN_ADDRESS)
 		return (EINVAL);
 #endif
+	mtx_lock(&Giant);
 	map = &p->p_vmspace->vm_map;
 	/*
 	 * Make sure entire range is allocated.
 	 */
-	mtx_lock(&Giant);
-	mtx_lock(&vm_mtx);
 	if (!vm_map_check_protection(map, addr, addr + size, VM_PROT_NONE)) {
-		mtx_unlock(&vm_mtx);
 		mtx_unlock(&Giant);
 		return (EINVAL);
 	}
 	/* returns nothing but KERN_SUCCESS anyway */
 	(void) vm_map_remove(map, addr, addr + size);
-	mtx_unlock(&vm_mtx);
 	mtx_unlock(&Giant);
 	return (0);
 }
@@ -674,10 +668,8 @@
 		return(EINVAL);
 
 	mtx_lock(&Giant);
-	mtx_lock(&vm_mtx);
 	ret = vm_map_protect(&p->p_vmspace->vm_map, addr,
 		     addr + size, prot, FALSE);
-	mtx_unlock(&vm_mtx);
 	mtx_unlock(&Giant);
 	switch (ret) {
 	case KERN_SUCCESS:
@@ -716,16 +708,10 @@
 	if (addr + size < addr)
 		return(EINVAL);
 
-#ifndef BLEED
 	mtx_lock(&Giant);
-#endif
-	mtx_lock(&vm_mtx);
 	ret = vm_map_inherit(&p->p_vmspace->vm_map, addr, addr+size,
 		    inherit);
-	mtx_unlock(&vm_mtx);
-#ifndef BLEED
 	mtx_unlock(&Giant);
-#endif
 
 	switch (ret) {
 	case KERN_SUCCESS:
@@ -779,15 +765,9 @@
 	start = trunc_page((vm_offset_t) uap->addr);
 	end = round_page((vm_offset_t) uap->addr + uap->len);
 	
-#ifndef BLEED
 	mtx_lock(&Giant);
-#endif
-	mtx_lock(&vm_mtx);
 	ret = vm_map_madvise(&p->p_vmspace->vm_map, start, end, uap->behav);
-	mtx_unlock(&vm_mtx);
-#ifndef BLEED
 	mtx_unlock(&Giant);
-#endif
 	return (ret ? EINVAL : 0);
 }
 
@@ -833,11 +813,8 @@
 	 */
 	vec = uap->vec;
 
-	map = &p->p_vmspace->vm_map;
-#ifndef BLEED
 	mtx_lock(&Giant);
-#endif
-	mtx_lock(&vm_mtx);
+	map = &p->p_vmspace->vm_map;
 	pmap = vmspace_pmap(p->p_vmspace);
 
 	vm_map_lock_read(map);
@@ -917,7 +894,6 @@
 			 * the map, we release the lock.
 			 */
 			vm_map_unlock_read(map);
-			mtx_unlock(&vm_mtx);
 
 			/*
 			 * calculate index into user supplied byte vector
@@ -931,9 +907,7 @@
 			while((lastvecindex + 1) < vecindex) {
 				error = subyte( vec + lastvecindex, 0);
 				if (error) {
-#ifndef BLEED
 					mtx_unlock(&Giant);
-#endif
 					return (EFAULT);
 				}
 				++lastvecindex;
@@ -944,9 +918,7 @@
 			 */
 			error = subyte( vec + vecindex, mincoreinfo);
 			if (error) {
-#ifndef BLEED
 				mtx_unlock(&Giant);
-#endif
 				return (EFAULT);
 			}
 
@@ -954,7 +926,6 @@
 			 * If the map has changed, due to the subyte, the previous
 			 * output may be invalid.
 			 */
-			mtx_lock(&vm_mtx);
 			vm_map_lock_read(map);
 			if (timestamp != map->timestamp)
 				goto RestartScan;
@@ -969,7 +940,6 @@
 	 * the map, we release the lock.
 	 */
 	vm_map_unlock_read(map);
-	mtx_unlock(&vm_mtx);
 
 	/*
 	 * Zero the last entries in the byte vector.
@@ -978,9 +948,7 @@
 	while((lastvecindex + 1) < vecindex) {
 		error = subyte( vec + lastvecindex, 0);
 		if (error) {
-#ifndef BLEED
 			mtx_unlock(&Giant);
-#endif
 			return (EFAULT);
 		}
 		++lastvecindex;
@@ -990,15 +958,11 @@
 	 * If the map has changed, due to the subyte, the previous
 	 * output may be invalid.
 	 */
-	mtx_lock(&vm_mtx);
 	vm_map_lock_read(map);
 	if (timestamp != map->timestamp)
 		goto RestartScan;
 	vm_map_unlock_read(map);
-	mtx_unlock(&vm_mtx);
-#ifndef BLEED
 	mtx_unlock(&Giant);
-#endif
 
 	return (0);
 }
@@ -1043,16 +1007,10 @@
 		return (error);
 #endif
 
-#ifndef BLEED
 	mtx_lock(&Giant);
-#endif
-	mtx_lock(&vm_mtx);
 	error = vm_map_user_pageable(&p->p_vmspace->vm_map, addr,
 		     addr + size, FALSE);
-	mtx_unlock(&vm_mtx);
-#ifndef BLEED
 	mtx_unlock(&Giant);
-#endif
 	return (error == KERN_SUCCESS ? 0 : ENOMEM);
 }
 
@@ -1067,6 +1025,8 @@
 	struct proc *p;
 	struct mlockall_args *uap;
 {
+	/* mtx_lock(&Giant); */
+	/* mtx_unlock(&Giant); */
 	return 0;
 }
 
@@ -1081,6 +1041,8 @@
 	struct proc *p;
 	struct munlockall_args *uap;
 {
+	/* mtx_lock(&Giant); */
+	/* mtx_unlock(&Giant); */
 	return 0;
 }
 
@@ -1117,16 +1079,10 @@
 		return (error);
 #endif
 
-#ifndef BLEED
 	mtx_lock(&Giant);
-#endif
-	mtx_lock(&vm_mtx);
 	error = vm_map_user_pageable(&p->p_vmspace->vm_map, addr,
 		     addr + size, TRUE);
-	mtx_unlock(&vm_mtx);
-#ifndef BLEED
 	mtx_unlock(&Giant);
-#endif
 	return (error == KERN_SUCCESS ? 0 : ENOMEM);
 }
 
@@ -1175,9 +1131,7 @@
 			return (EINVAL);
 		fitit = FALSE;
 		mtx_lock(&Giant);
-		mtx_lock(&vm_mtx);
 		(void) vm_map_remove(map, *addr, *addr + size);
-		mtx_unlock(&vm_mtx);
 	}
 
 	/*
@@ -1252,7 +1206,6 @@
 		maxprot |= VM_PROT_EXECUTE;
 #endif
 
-	mtx_lock(&vm_mtx);
 	if (fitit)
 		*addr = pmap_addr_hint(object, *addr, size);
 
@@ -1279,7 +1232,6 @@
 		if (rv != KERN_SUCCESS)
 			(void) vm_map_remove(map, *addr, *addr + size);
 	}
-	mtx_unlock(&vm_mtx);
 	mtx_unlock(&Giant);
 	switch (rv) {
 	case KERN_SUCCESS:
Index: vm/vm_object.c
===================================================================
RCS file: /home/ncvs/src/sys/vm/vm_object.c,v
retrieving revision 1.193
diff -u -r1.193 vm_object.c
--- vm/vm_object.c	2001/06/22 06:35:23	1.193
+++ vm/vm_object.c	2001/07/04 02:54:17
@@ -147,7 +147,8 @@
 {
 	int incr;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
+
 	TAILQ_INIT(&object->memq);
 	TAILQ_INIT(&object->shadow_head);
 
@@ -192,8 +193,8 @@
 void
 vm_object_init()
 {
+	GIANT_REQUIRED;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
 	TAILQ_INIT(&vm_object_list);
 	mtx_init(&vm_object_list_mtx, "vm object_list", MTX_DEF);
 	vm_object_count = 0;
@@ -229,8 +230,9 @@
 	vm_size_t size;
 {
 	vm_object_t result;
+
+	GIANT_REQUIRED;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
 	result = (vm_object_t) zalloc(obj_zone);
 	_vm_object_allocate(type, size, result);
 
@@ -247,8 +249,8 @@
 vm_object_reference(object)
 	vm_object_t object;
 {
+	GIANT_REQUIRED;
 
-	mtx_assert(VM_OBJECT_MTX(object), MA_OWNED);
 	if (object == NULL)
 		return;
 
@@ -257,20 +259,14 @@
 
 	object->ref_count++;
 	if (object->type == OBJT_VNODE) {
-		mtx_unlock(VM_OBJECT_MTX(object));
-		mtx_assert(&Giant, MA_OWNED);
 		while (vget((struct vnode *) object->handle, LK_RETRY|LK_NOOBJ, curproc)) {
 			printf("vm_object_reference: delay in getting object\n");
 		}
-		mtx_lock(VM_OBJECT_MTX(object));
 	}
 }
 
 /*
  * handle deallocating a object of type OBJT_VNODE
- *
- * requires vm_mtx
- * may block
  */
 void
 vm_object_vndeallocate(object)
@@ -278,7 +274,7 @@
 {
 	struct vnode *vp = (struct vnode *) object->handle;
 
-	mtx_assert(VM_OBJECT_MTX(object), MA_OWNED);
+	GIANT_REQUIRED;
 	KASSERT(object->type == OBJT_VNODE,
 	    ("vm_object_vndeallocate: not a vnode object"));
 	KASSERT(vp != NULL, ("vm_object_vndeallocate: missing vp"));
@@ -297,10 +293,7 @@
 	/*
 	 * vrele may need a vop lock
 	 */
-	mtx_unlock(VM_OBJECT_MTX(object));
-	mtx_assert(&Giant, MA_OWNED);
 	vrele(vp);
-	mtx_lock(VM_OBJECT_MTX(object));
 }
 
 /*
@@ -313,15 +306,15 @@
  *	may be relinquished.
  *
  *	No object may be locked.
- *	vm_mtx must be held
  */
 void
 vm_object_deallocate(object)
 	vm_object_t object;
 {
 	vm_object_t temp;
+
+	GIANT_REQUIRED;
 
-	mtx_assert(VM_OBJECT_MTX(object), MA_OWNED);
 	while (object != NULL) {
 
 		if (object->type == OBJT_VNODE) {
@@ -355,9 +348,6 @@
 				    ("vm_object_deallocate: ref_count: %d, shadow_count: %d",
 					 object->ref_count,
 					 object->shadow_count));
-#ifdef objlocks
-				mtx_lock(VM_OBJECT_MTX(robject));
-#endif
 				if ((robject->handle == NULL) &&
 				    (robject->type == OBJT_DEFAULT ||
 				     robject->type == OBJT_SWAP)) {
@@ -368,32 +358,16 @@
 						robject->paging_in_progress ||
 						object->paging_in_progress
 					) {
-#ifdef objlocks
-						mtx_unlock(VM_OBJECT_MTX(object));
-#endif
 						vm_object_pip_sleep(robject, "objde1");
-#ifdef objlocks
-						mtx_unlock(VM_OBJECT_MTX(robject));
-						mtx_lock(VM_OBJECT_MTX(object));
-#endif
 						vm_object_pip_sleep(object, "objde2");
-#ifdef objlocks
-						mtx_lock(VM_OBJECT_MTX(robject));
-#endif
 					}
 
 					if (robject->ref_count == 1) {
 						robject->ref_count--;
-#ifdef objlocks
-						mtx_unlock(VM_OBJECT_MTX(object));
-#endif
 						object = robject;
 						goto doterm;
 					}
 
-#ifdef objlocks
-					mtx_unlock(VM_OBJECT_MTX(object));
-#endif
 					object = robject;
 					vm_object_collapse(object);
 					continue;
@@ -434,9 +408,9 @@
 {
 	vm_page_t p;
 	int s;
+
+	GIANT_REQUIRED;
 
-	mtx_assert(&Giant, MA_OWNED);
-	mtx_assert(VM_OBJECT_MTX(object), MA_OWNED);
 	/*
 	 * Make sure no one uses us.
 	 */
@@ -468,9 +442,7 @@
 		vm_object_page_clean(object, 0, 0, OBJPC_SYNC);
 
 		vp = (struct vnode *) object->handle;
-		mtx_unlock(VM_OBJECT_MTX(object));
 		vinvalbuf(vp, V_SAVE, NOCRED, NULL, 0, 0);
-		mtx_lock(VM_OBJECT_MTX(object));
 	}
 
 	KASSERT(object->ref_count == 0, 
@@ -555,7 +527,8 @@
 	vm_page_t ma[vm_pageout_page_count];
 	int curgeneration;
 
-	mtx_assert(VM_OBJECT_MTX(object), MA_OWNED);
+	GIANT_REQUIRED;
+
 	if (object->type != OBJT_VNODE ||
 		(object->flags & OBJ_MIGHTBEDIRTY) == 0)
 		return;
@@ -762,8 +735,9 @@
 {
 	vm_pindex_t idx;
 	vm_page_t p;
+
+	GIANT_REQUIRED;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
 	if (object == NULL || (object->flags & OBJ_WRITEABLE) == 0)
 		return;
 
@@ -791,7 +765,7 @@
 {
 	vm_page_t p;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
 	if (object == NULL)
 		return;
 	TAILQ_FOREACH(p, &object->memq, listq) {
@@ -834,7 +808,7 @@
 	vm_object_t tobject;
 	vm_page_t m;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
 	if (object == NULL)
 		return;
 
@@ -948,7 +922,7 @@
 	vm_object_t source;
 	vm_object_t result;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
 	source = *object;
 
 	/*
@@ -1015,7 +989,7 @@
 	vm_pindex_t backing_offset_index;
 
 	s = splvm();
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
 
 	backing_object = object->backing_object;
 	backing_offset_index = OFF_TO_IDX(object->backing_object_offset);
@@ -1229,8 +1203,7 @@
 vm_object_collapse(object)
 	vm_object_t object;
 {
-
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
 	
 	while (TRUE) {
 		vm_object_t backing_object;
@@ -1443,7 +1416,7 @@
 	unsigned int size;
 	int all;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
 	
 	if (object == NULL ||
 	    object->resident_page_count == 0)
@@ -1561,7 +1534,7 @@
 {
 	vm_pindex_t next_pindex;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
 
 	if (prev_object == NULL) {
 		return (TRUE);
Index: vm/vm_object.h
===================================================================
RCS file: /home/ncvs/src/sys/vm/vm_object.h,v
retrieving revision 1.71
diff -u -r1.71 vm_object.h
--- vm/vm_object.h	2001/05/19 01:28:09	1.71
+++ vm/vm_object.h	2001/07/04 02:54:17
@@ -169,49 +169,44 @@
 
 #ifdef _KERNEL
 
-/*
- * For now a global vm lock.
- */
-#define	VM_OBJECT_MTX(object)	(&vm_mtx)
-
 static __inline void
 vm_object_set_flag(vm_object_t object, u_short bits)
 {
-
-	mtx_assert(VM_OBJECT_MTX(object), MA_OWNED);
-	object->flags |= bits;
+	GIANT_REQUIRED;
+	atomic_set_short(&object->flags, bits);
+	/* object->flags |= bits; */
 }
 
 static __inline void
 vm_object_clear_flag(vm_object_t object, u_short bits)
 {
-
-	mtx_assert(VM_OBJECT_MTX(object), MA_OWNED);
-	object->flags &= ~bits;
+	GIANT_REQUIRED;
+	atomic_clear_short(&object->flags, bits);
+	/* object->flags &= ~bits; */
 }
 
 static __inline void
 vm_object_pip_add(vm_object_t object, short i)
 {
-
-	mtx_assert(VM_OBJECT_MTX(object), MA_OWNED);
-	object->paging_in_progress += i;
+	GIANT_REQUIRED;
+	atomic_add_short(&object->paging_in_progress, i);
+	/* object->paging_in_progress += i; */
 }
 
 static __inline void
 vm_object_pip_subtract(vm_object_t object, short i)
 {
-
-	mtx_assert(VM_OBJECT_MTX(object), MA_OWNED);
-	object->paging_in_progress -= i;
+	GIANT_REQUIRED;
+	atomic_subtract_short(&object->paging_in_progress, i);
+	/* object->paging_in_progress -= i; */
 }
 
 static __inline void
 vm_object_pip_wakeup(vm_object_t object)
 {
-
-	mtx_assert(VM_OBJECT_MTX(object), MA_OWNED);
-	object->paging_in_progress--;
+	GIANT_REQUIRED;
+	atomic_subtract_short(&object->paging_in_progress, 1);
+	/* object->paging_in_progress--; */
 	if ((object->flags & OBJ_PIPWNT) && object->paging_in_progress == 0) {
 		vm_object_clear_flag(object, OBJ_PIPWNT);
 		wakeup(object);
@@ -221,10 +216,9 @@
 static __inline void
 vm_object_pip_wakeupn(vm_object_t object, short i)
 {
-
-	mtx_assert(VM_OBJECT_MTX(object), MA_OWNED);
+	GIANT_REQUIRED;
 	if (i)
-		object->paging_in_progress -= i;
+		atomic_subtract_short(&object->paging_in_progress, i);
 	if ((object->flags & OBJ_PIPWNT) && object->paging_in_progress == 0) {
 		vm_object_clear_flag(object, OBJ_PIPWNT);
 		wakeup(object);
@@ -234,13 +228,12 @@
 static __inline void
 vm_object_pip_sleep(vm_object_t object, char *waitid)
 {
-
-	mtx_assert(VM_OBJECT_MTX(object), MA_OWNED);
+	GIANT_REQUIRED;
 	if (object->paging_in_progress) {
 		int s = splvm();
 		if (object->paging_in_progress) {
 			vm_object_set_flag(object, OBJ_PIPWNT);
-			msleep(object, VM_OBJECT_MTX(object), PVM, waitid, 0);
+			tsleep(object, PVM, waitid, 0);
 		}
 		splx(s);
 	}
@@ -249,8 +242,7 @@
 static __inline void
 vm_object_pip_wait(vm_object_t object, char *waitid)
 {
-
-	mtx_assert(VM_OBJECT_MTX(object), MA_OWNED);
+	GIANT_REQUIRED;
 	while (object->paging_in_progress)
 		vm_object_pip_sleep(object, waitid);
 }
